#include <QCoreApplication>
#include <QTextCodec>
#include <iostream>
#include <cmath>

using namespace std;
const double PI = atan(1)*4;

double Cos(double x, int &N, double eps){
   int sign = x<0?-1:1;
   while(x*sign> 2*PI) x -= sign*2*PI;

   N=0;
   sign = -1;
   double sum = 0, temp=1;
   while (eps <= abs(temp)) { //оценка с помощью остаточного члена в форме Лагранжа
      sum += temp;
      ++N;
      temp = temp*sign*x*x/(2*N*(2*N-1));
   }
   return sum;
}

int main(int argc, char *argv[])
{
   QCoreApplication a(argc, argv);

#ifdef Q_OS_WIN32
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("IBM 866"));
#endif

#ifdef Q_OS_LINUX
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("UTF-8"));
#endif
    //QString::fromUtf8("Текст ").toLocal8Bit().data()

    double xbeg, xend, dx, eps;
    int N;
    const int PREC = 6; //precision
    cout << QString::fromUtf8("Введите Хнач, Хкон, dX, eps через пробел: ").toLocal8Bit().data();
    cin >> xbeg >> xend >> dx >> eps;

    cout << QString::fromUtf8("\nВычисление cos(x) путем разложения в ряд Тейлора ").toLocal8Bit().data() << endl;
    cout << "--------------------------------------------------\n";
    cout <<"| ";
    cout.width(12);
    cout << left <<  "Arg";
    cout <<"| ";
    cout.width(12);
    cout << left << "Analytyc";
    cout <<"| ";
    cout.width(12);
    cout << left << "Taylor";
    cout <<"| ";
    cout.width(5);
    cout << right << "N";
    cout <<"|" << endl;
    cout << "--------------------------------------------------\n";

    for (double x = xbeg;x<=xend; x+=dx) {
       cout <<"| ";
       cout.width(12);
       cout.precision(PREC);
       cout << left << x;
       cout <<"| ";
       cout.width(12);
       cout.precision(PREC);
       cout << left << cos(x);
       cout <<"| ";
       cout.width(12);
       cout.precision(PREC);
       cout<< left << Cos(x,N, eps);
       cout <<"| ";
       cout.width(5);
       cout << right << N;
       cout <<"|" << endl;
    }


   return a.exec();
}
