#include <QCoreApplication>
#include <QTextCodec>
#include <iostream>
#include <fstream>
#include <algorithm>

using namespace std;

int** getmas(int n, int m) {
   int ** mas;

   mas = new int*[n];
   for (int i = 0; i < n; ++i) mas[i] = new int[m];

   return mas;
}

void shiftRing(int u, int n, int m, int k, int** &mas) {
   int lenOfRing = 2*(n+m-2-4*u);
   k = (k%lenOfRing + lenOfRing) % lenOfRing; //чтобы k был положительным, обозначает смещение направо
   int *temp = new int[lenOfRing];

   int i = 0, j;
   for(j=u; j<m-u; ++j) temp[i++] = mas[u][j];
   for(j=u+1; j<n-u; ++j) temp[i++] = mas[j][m-u-1];
   for(j=m-u-2; j>=u; --j) temp[i++] = mas[n-u-1][j];
   for(j=n-u-2; j>u; --j) temp[i++] = mas[j][u];

   rotate(temp, temp + (lenOfRing-k), temp+lenOfRing);//смещает массив так, чтобы первым элементом массива стал temp[lenOfRing-k]

   i = 0;
   for(j=u; j<m-u; ++j) mas[u][j] = temp[i++];
   for(j=u+1; j<n-u; ++j) mas[j][m-u-1]  = temp[i++];
   for(j=m-u-2; j>=u; --j) mas[n-u-1][j]  = temp[i++];
   for(j=n-u-2; j>u; --j) mas[j][u]  = temp[i++];

   delete[] temp;

}

void shift(int n, int m, int k, int** &mas) {
   for(int u = 0; u < min(n/2, m/2); ++u) {
      shiftRing(u,n,m,k,mas);
   }
}

int main(int argc, char *argv[])
{
   QCoreApplication a(argc, argv);


#ifdef Q_OS_WIN32
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("IBM 866"));
#endif

#ifdef Q_OS_LINUX
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("UTF-8"));
#endif

   ifstream fin("input.txt");
   int n, m, **mas, k;

   if (!fin.is_open()) cout << QString::fromUtf8("Не найден файл input.txt. Он должен находиться в том же каталоге, что и исполнительный файл программы").toLocal8Bit().data() << endl;
   else {
      fin >> n >> m;
      mas = getmas(n,m);

      for (int i = 0; i < n; ++i) {
         for (int j = 0; j < m; ++j) {
            fin >> mas[i][j];
         }
      }

      cout << QString::fromUtf8("Введите k: ").toLocal8Bit().data();
      while (cin >> k) {
         shift(n,m,k,mas);

         for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
               cout.width(4);
               cout << mas[i][j];
            }
            cout << "\n";
         }

         cout << endl << QString::fromUtf8("Введите k: ").toLocal8Bit().data();
      }



   }

   return a.exec();
}
