#include <QCoreApplication>
#include <QTextCodec>
#include <QProcess>
#include <string>
#include <iostream>
#include <cstdio>
#include <cmath>
using namespace std;


void clearScreen() {
#ifdef Q_OS_WIN32
    QProcess::execute("CLS");
#endif

#ifdef Q_OS_LINUX
    QProcess::execute("clear");
#endif
}

struct Notebook {
   char model[21];
   struct {
      float x;
      float y;
      float z;
   }size;
   int price;
   int w;
};

void Print(Notebook &nt) {
   cout << endl;
   cout << "Model : " << nt.model << endl;
   cout << "Size x: " << nt.size.x << endl;
   cout << "     y: " << nt.size.y << endl;
   cout << "     z: " << nt.size.z << endl;
   cout << "Price : " << nt.price << endl;
   cout << "Weight: " << nt.w << endl;
}

bool Read(FILE * fin, Notebook &temp) {
   bool success = 6 == fscanf(fin,"%s %f %f %f %d %d", temp.model, &temp.size.x, &temp.size.y, &temp.size.z, &temp.price, &temp.w);
   return success;
}

unsigned int WriteBin(FILE* fout, Notebook & nt) {
   return fwrite(&nt, sizeof(nt), 1, fout);
}

int main(int argc, char *argv[])
{
   QCoreApplication a(argc, argv);

#ifdef Q_OS_WIN32
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("IBM 866"));
#endif

#ifdef Q_OS_LINUX
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("UTF-8"));
#endif
    //QString::fromUtf8("Текст ").toLocal8Bit().data()

    FILE* fin = fopen("note.txt", "r");
    FILE* fbin = fopen("note.bin", "ab+");

    Notebook temp;

    while(Read(fin, temp)) {
       if (11 < sqrt(temp.size.x * temp.size.x + temp.size.y * temp.size.y)) {
          WriteBin(fbin, temp);
       }
    }

    cout << QString::fromUtf8("Выполнено... Нажмите Enter, чтобы посмотреть, что содержится в note.bin файле ").toLocal8Bit().data() << endl;
    getchar();

    fseek(fbin, 0, SEEK_SET);
    while(1 == fread(&temp, sizeof(Notebook), 1, fbin )) Print(temp);
   return a.exec();
}
